<?php

/**
*
* @package phpBB Canonical URL & Topic SEO hook, v.1.0.2
* @copyright (c) 2015 www.phpbb-work.ru
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

function gen_canonical()
{
	global $canonical, $topic_data, $topic_id, $forum_id, $start, $template, $user, $phpEx;

	if (isset($canonical))
	{
		return;
	}

	$script_name = str_replace('.' . $phpEx, '', $user->page['page_name']);

	switch ($script_name)
	{
		case 'index':
			$canonical = generate_board_url() . '/';
		break;

		case 'viewforum':
			$canonical = generate_board_url() . "/viewforum.$phpEx?f=$forum_id" . (($start) ? "&amp;start=$start" : '');
		break;

		case 'viewtopic':
			$canonical = generate_board_url() . "/viewtopic.$phpEx?t=$topic_id" . (($start) ? "&amp;start=$start" : '');
		break;

		default:
			$canonical = '';
		break;
	}

	if (isset($template->_rootref['META']))
	{
		$template->_rootref['META'] = str_replace('?f=' . $forum_id . '&amp;t=', '?t=', $template->_rootref['META']);
	}

	if ($canonical && !isset($template->_rootref['META']))
	{
		$template->_rootref['META'] = '<link rel="canonical" href="' . $canonical . '" />';
	}

	ob_start();
}

function who_is_online_fix()
{
	global $db, $forum_id, $user, $phpEx;

	if ($forum_id && !$user->page['forum'] && $user->page['page_name'] === 'viewtopic.' . $phpEx)
	{
		$sql = 'UPDATE ' . SESSIONS_TABLE . ' SET session_forum_id = ' . $forum_id . '
			WHERE session_id = \'' . $db->sql_escape($user->session_id) . '\'
			AND session_user_id = ' . $user->data['user_id'];
		$result = $db->sql_query($sql);
	}
}

function remove_forum_id()
{
	global $phpEx;

	$content = ob_get_clean();

	$urlin = array(
		"/\.\/viewtopic.$phpEx\?f=(?:[0-9]*)&(?:amp;)(p|t)=([0-9]*)(.*?)\"/i",
		"/\.\/viewtopic.$phpEx\?t=([0-9]*)&(?:amp;)f=(?:[0-9]*)(.*?)\"/i",
		"/\.\/view(topic|forum).$phpEx(.*?)&(?:amp;start=0)(.*?)\"/i",
	);
	$urlout = array(
		'./viewtopic.' . $phpEx . '?\\1=\\2\\3"',
		'./viewtopic.' . $phpEx . '?t=\\1\\2"',
		'./view\\1.' . $phpEx . '\\2\\3"',
	);

	echo preg_replace($urlin, $urlout, $content);
}

$phpbb_hook->register(array('template', 'display'), 'gen_canonical');
$phpbb_hook->register('phpbb_user_session_handler', 'who_is_online_fix');
$phpbb_hook->register('exit_handler', 'remove_forum_id');

?>